http://acm.hdu.edu.cn/showproblem.php?pid=6536
题意:不重复元素,求子串为xtCpc的数量最大
题解:这是一道很简单的贪心题目,因为xtCpc这5个字母各不相同,所以直接采取贪心的策略,对于所有的“x”,“t”,“C”,”p”,”c”按照字母不同分别建立一个队列,每次贪心的从队列中找到最前面的没有使用过的字母,直到有一个队列为空。
C++版本一
/*
*@Author: STZG
*@Language: C++
*/
#include <bits/stdc++.h>
#include<iostream>
#include<algorithm>
#include<cstdlib>
#include<cstring>
#include<cstdio>
#include<string>
#include<vector>
#include<bitset>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<list>
#include<map>
#include<set>
//#define DEBUG
#define RI register int
#define endl "\n"
using namespace std;
typedef long long ll;
//typedef __int128 lll;
const int N=200000+10;
const int M=100000+10;
const int MOD=1e9+7;
const double PI = acos(-1.0);
const double EXP = 1E-8;
const int INF = 0x3f3f3f3f;
int t,n,m,k,p,l,r,u,v;
int ans,cnt,flag,temp,sum;
string str;
struct node{};
int main()
{
#ifdef DEBUG
freopen("input.in", "r", stdin);
//freopen("output.out", "w", stdout);
#endif
//ios::sync_with_stdio(false);
//cin.tie(0);
//cout.tie(0);
//scanf("%d",&t);
//while(t--){
while(~scanf("%d",&n)){
ans=0;
cin>>str;
queue<int>q[5];
for(int i=0;i<n;i++){
if(str[i]=='x'){
q[0].push(i);
}else if(str[i]=='t'){
q[1].push(i);
}else if(str[i]=='C'){
q[2].push(i);
}else if(str[i]=='p'){
q[3].push(i);
}else if(str[i]=='c'){
q[4].push(i);
}
}
while(!q[0].empty()){
int pos=q[0].front();
q[0].pop();
flag=1;
for(int i=1;i<5;i++){
while(!q[i].empty()&&pos>q[i].front())q[i].pop();
if(q[i].empty()){
flag=0;
break;
}
pos=q[i].front();
q[i].pop();
}
if(!flag)break;
ans++;
}
cout<<ans<<endl;
}
//}
#ifdef DEBUG
printf("Time cost : %lf s\n",(double)clock()/CLOCKS_PER_SEC);
#endif
//cout << "Hello world!" << endl;
return 0;
}